// Generated by CoffeeScript 1.12.7
var AdminEventManagerEvent,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

AdminEventManagerEvent = (function(superClass) {
  extend(AdminEventManagerEvent, superClass);

  function AdminEventManagerEvent() {
    return AdminEventManagerEvent.__super__.constructor.apply(this, arguments);
  }

  AdminEventManagerEvent.prototype.initOpts = function() {
    AdminEventManagerEvent.__super__.initOpts.call(this);
    return this.addOpts({
      event: {
        check: "PlainObject"
      }
    });
  };

  AdminEventManagerEvent.prototype.readOpts = function() {
    AdminEventManagerEvent.__super__.readOpts.call(this);
    return this.__event = this._event;
  };

  AdminEventManagerEvent.prototype.renderContent = function() {
    this.addColumn(new CUI.ListViewColumn({
      text: this.getTimestamp()
    }));
    this.addColumn(new CUI.ListViewColumn({
      text: this.getUserGeneratedDisplayname()
    }));
    this.addColumn(new CUI.ListViewColumn({
      text: AdminEventManager.locaType(this.getType())
    }));
    this.addColumn(new CUI.ListViewColumn({
      text: this.getType()
    }));
    return new CUI.Label({
      text: this.getID()
    });
  };

  AdminEventManagerEvent.prototype.isDeletable = function() {
    return true;
  };

  AdminEventManagerEvent.prototype.getEvent = function() {
    return this.__event.event;
  };

  AdminEventManagerEvent.prototype.getType = function() {
    return this.getEvent().type;
  };

  AdminEventManagerEvent.prototype.getID = function() {
    return this.getEvent()._id;
  };

  AdminEventManagerEvent.prototype.getUserGeneratedDisplayname = function() {
    if (this.__event.user) {
      return this.__event.user._generated_displayname || ("" + this.__event.user._id);
    } else {
      return $$("admin.event.manager.user_generated_displayname.system");
    }
  };

  AdminEventManagerEvent.prototype.registerDataChangedListener = function() {};

  AdminEventManagerEvent.prototype.load = function() {
    var ref;
    if (((ref = this.manager.getTree().getSelectedRows()) != null ? ref.length : void 0) > 1) {
      return CUI.resolvedPromise();
    }
    return ez5.api.event({
      api: "/" + this.getID()
    }).done((function(_this) {
      return function(__event) {
        _this.__event = __event;
      };
    })(this));
  };

  AdminEventManagerEvent.prototype.getTimestamp = function() {
    return ez5.format_date_and_time(this.getEvent().timestamp, true);
  };

  AdminEventManagerEvent.prototype.getPaneContent = function() {
    var assetId, ev, field, fields, getAssetId, getSystemObjectIdFromGlobalId, i, k, label, len, objectDumper, ref, ref1, ref2, ref3, showObjectModalButton, value;
    ev = this.getEvent();
    fields = [];
    getAssetId = (function(_this) {
      return function() {
        var ref, value;
        value = (ref = ev.info) != null ? ref.asset_id : void 0;
        if (!value && ev.object_id && ev.basetype === "asset") {
          value = ev.object_id;
        }
        return value;
      };
    })(this);
    getSystemObjectIdFromGlobalId = (function(_this) {
      return function() {
        var gid, instance, ref, ref1, ref2, soId;
        gid = ev.global_object_id || ((ref = ev.info) != null ? ref.global_object_id : void 0);
        if (CUI.util.isEmpty(gid)) {
          return null;
        }
        ref1 = ("" + gid).split("@"), soId = ref1[0], instance = ref1[1];
        if (instance === ((ref2 = ez5.session.getInstance()) != null ? ref2.name : void 0)) {
          return parseInt(soId);
        } else {
          return null;
        }
      };
    })(this);
    ref = ["_id", "type", "timestamp", "remote_addr", "object_version", "schema", "user_generated_displayname", "basetype", "objecttype", "object_id", "global_object_id", "system_object_id", "asset_id", "info"];
    for (i = 0, len = ref.length; i < len; i++) {
      k = ref[i];
      switch (k) {
        case "timestamp":
          value = this.getTimestamp();
          break;
        case "user_generated_displayname":
          value = this.getUserGeneratedDisplayname();
          break;
        case "type":
          value = AdminEventManager.locaType(ev[k]) + ' [' + ev[k] + ']';
          break;
        case "global_object_id":
          value = ev.global_object_id || ((ref1 = ev.info) != null ? ref1.global_object_id : void 0);
          break;
        case "system_object_id":
          value = ((ref2 = ev.info) != null ? ref2.system_object_id : void 0) || getSystemObjectIdFromGlobalId();
          break;
        case "object_id":
          assetId = getAssetId();
          if (!assetId) {
            value = ev.object_id || ((ref3 = ev.info) != null ? ref3.object_id : void 0);
          }
          break;
        case "asset_id":
          value = getAssetId();
          break;
        default:
          value = ev[k];
      }
      if (CUI.util.isEmpty(value)) {
        continue;
      }
      if (CUI.isPlainObject(value) || CUI.isArray(value)) {
        objectDumper = new CUI.ObjectDumper({
          object: value,
          parse_json: true
        });
        fields.push(this.__getOutputContentField(objectDumper, k));
      } else if (value instanceof CUI.DOMElement) {
        fields.push(this.__getOutputContentField(value, k));
      } else {
        showObjectModalButton = null;
        field = {
          form: {
            label: $$("admin.event.manager.column." + k + "|text")
          }
        };
        showObjectModalButton = this.__getObjectModalButton(value, k, ev);
        if (showObjectModalButton) {
          label = new CUI.Label({
            text: value
          });
          field.type = CUI.OutputContent;
          field.content = new CUI.HorizontalList({
            content: [label, CUI.dom.space(), showObjectModalButton]
          });
        } else {
          field.type = CUI.Output;
          field.text = value + "";
        }
        fields.push(field);
      }
    }
    return new CUI.Form({
      fields: fields
    }).start();
  };

  AdminEventManagerEvent.prototype.getEditorPane = function() {
    return new CUI.SimplePane({
      "class": "cui-pane--window",
      header_left: this.manager.getTitle(),
      padded: true,
      content: this.getPaneContent(),
      footer_right: (function(_this) {
        return function() {
          return new LocaButton({
            loca_key: "admin.event.manager.event.button.close",
            onClick: function() {
              return _this.deselect();
            }
          });
        };
      })(this)
    });
  };

  AdminEventManagerEvent.prototype.__getOutputContentField = function(content, key) {
    return {
      type: CUI.OutputContent,
      maximize_horizontal: true,
      content: content,
      form: {
        label: $$("admin.event.manager.column." + key + "|text")
      }
    };
  };

  AdminEventManagerEvent.prototype.__getObjectModalButton = function(id, type, event) {
    if (event.type === "OBJECT_DELETE") {
      return;
    }
    if (type === "object_id" && !event.objecttype) {
      return;
    }
    if (type !== "global_object_id" && type !== "system_object_id" && type !== "asset_id" && type !== "object_id") {
      return;
    }
    return new CUI.Button({
      size: "mini",
      text: $$("admin.event.manager.column.show_object.button"),
      onClick: (function(_this) {
        return function() {
          var easFields, loadPromise, objectTypeManager, resultObject, search_data;
          ez5.splash.show("admin.event.manager.splash.loading-object");
          if (type === "global_object_id") {
            loadPromise = ResultObject.loadFromGlobalObjectId(id);
          } else if (type === "system_object_id") {
            loadPromise = (new ResultObject()).loadFromSystemObjectId(id, "long");
          } else if (type === "object_id") {
            resultObject = new ResultObject();
            search_data = {
              format: "long",
              search: [
                {
                  type: "in",
                  fields: [event.objecttype + "._id"],
                  "in": [id]
                }
              ]
            };
            loadPromise = resultObject.loadFromSearch(search_data);
          } else if (type === "asset_id") {
            objectTypeManager = new ObjecttypeManager().addObjecttypes(function(table) {
              return !table.getSchema()._instance;
            });
            easFields = objectTypeManager.getEASFields("expert").map(function(easField) {
              return easField.fullName() + "._id";
            });
            resultObject = new ResultObject();
            search_data = {
              format: "long",
              search: [
                {
                  type: "in",
                  fields: easFields,
                  "in": [id]
                }
              ]
            };
            loadPromise = resultObject.loadFromSearch(search_data);
          }
          return loadPromise.done(function(resultObject) {
            return resultObject.showModal();
          }).always(function() {
            return ez5.splash.hide();
          }).fail(function() {
            return CUI.alert({
              text: $$("admin.event.manager.alert.object_not_found")
            });
          });
        };
      })(this)
    });
  };

  AdminEventManagerEvent.prototype["delete"] = function() {
    return this.manager.__deleteMultipleById([this.getID()]);
  };

  AdminEventManagerEvent.prototype.select = function(ev) {
    if (this.manager.__loadedEvent !== this.getID()) {
      this.manager.__loadedEvent = this.getID();
    } else {
      this.manager.__loadedEvent = null;
      this.deselect();
      return CUI.rejectedPromise();
    }
    return AdminEventManagerEvent.__super__.select.call(this, ev);
  };

  return AdminEventManagerEvent;

})(SystemListManagerItem);
